<?php if(! WsdUtil::canLoad()) { return; } ?>
<?php /*[Changing the db prefix is not available in MultiSite (yet)]*/
if(wpsIsMultisite()){
    echo '<p>Эта функция пока не доступна для MultiSite.</p>';
    return;
}
$wpsIsPostBack = ($_SERVER['REQUEST_METHOD'] == 'POST');
if ($wpsIsPostBack)
{
    if(wpsIsMultisite()){ wp_die('<p>Эта функция пока не доступна для MultiSite.</p>'); }
}
?>
<?php
/*
* =====================================================================================
* 	Because this feature is error prone and the blog can go "bye-bye" in a second,
* 	ensure we've checked EVERYTHING before displaying the form
* =====================================================================================
*/
	global $table_prefix;

	//## Assume FALSE
	$showPage = false;            // whether or not to display this page
	$isWPConfigWritable = false;  // whether or not the wp-config file is writable
	$cdtpIsPostBack = false;      // whether or not the form was posted back.
    $acxInfoMessage = $wsd_Message = ''; // Hold the error/info messages generated on form postback
	$old_prefix = $table_prefix;
	$new_prefix = ''; // leave empty. it will be populated at runtime
    $canAlter = false;  // Assume the user doesn't have ALTER rights

	$wpConfigFile = trailingslashit(ABSPATH).'wp-config.php';
    $acx_dbRights = WsdInfoServer::getDatabaseUserAccessRights();

	if (is_writable($wpConfigFile)){
		$isWPConfigWritable = true;
	}

    if ($acx_dbRights['rightsEnough']) {
        $canAlter = true;
    }

	//!! Check wp-config.php file and rights first
	if ($isWPConfigWritable && $canAlter){
		$showPage = true;
	}

    // Check if user has enough rights to alter the Table structure
    if ($acx_dbRights['rightsEnough'])
	{
        $_canAlter = '<span style="color: #060; font-weight: 900;">('.__('Да').')</span>';
    }
    else { $_canAlter = '<span style="color: #f00; font-weight: 900;">('.__('Нет').')</span>'; }

	if ($isWPConfigWritable)
	{
		$wpConfigFileinfo = '<span style="color: #060; font-weight: 900;">('.__('Да').')</span>';
	}
	else { $wpConfigFileinfo = '<span style="color: #f00; font-weight: 900;">('.__('Нет').')</span>'; }
?>

<div class="acx-section-box">
    <p><?php echo __('Измените префикс базы данных, чтобы избежать SQL Injection.');?></p>
    <h4 style="margin-top: 15px;"><?php echo __('Перед запуском этого сценария');?>:</h4>
    <ul class="acx-common-list" style="margin-top: 20px;">
        <li><?php echo __('The <code>wp-config.php</code> file must be <strong>writable</strong>.').' '.$wpConfigFileinfo;?></li>
        <li><?php echo __("Пользователь базы данных которого вы используете для подключения к базе данных должен иметь <strong>ALTER</strong> права.").' '.$_canAlter;?></li>
    </ul>
</div>

<?php
/*
 * Если пользователь doesn't have ALTER rights or the wp-config file is not writable
 *============================================================================
 */
//@ if all good but we cannot use the "file' function, stop here
if ($showPage && !function_exists('file'))
{
	echo '<p class="acx-info-box">';
        echo '<span class="acx-icon-alert-info">';
            echo __('Для того, чтобы изменить <code>wp-config.php</code> нуженый нам файл <strong>file</strong> функция, которая, кажется, в черном списке администратора сервера!');
        echo '</span>';
	echo '</p>';

    return;
}

//@ If we cannot load the page
if ( ! $showPage )
{
	echo '<p class="acx-info-box">';
		if (!$canAlter) {
            echo '<span class="acx-icon-alert-critical">';
                echo __('Пользователь который используется для доступа к базе данных должен иметь <strong>ALTER</strong> права для того, чтобы выполнить это действие!');
            echo '</span><br/>';
		}
		if (!$isWPConfigWritable) {
            echo '<span>';
            	echo __('Файл <strong>wp-config ДОЛЖЕН</strong> быть доступен для записи!');
            echo '</span>';
		}
	echo '</p>';

    //!! Stop here, no need to load the rest of the page
    return;
}
?>

<?php
/*
 * Issue the file permissions warning ONLY IF wp-config IS WRITABLE,
 * otherwise the form gets confusing displaying so many info messages...
 *======================================================================
 */
 	if ($isWPConfigWritable)
	{
		echo '<p class="acx-info-box">';
            echo '<span class="acx-icon-alert-info">';
                echo __('Это риск для безопасности, чтобы ваши файлы <strong>записи</strong>!
                    Пожалуйста, убедитесь, что <strong>after</strong>, что скрипт работает и в файле <code>wp-config.php</code> установлены разрешения 0644 или более ограничительные. Посмотреть: <a href="http://codex.wordpress.org/Changing_File_Permissions" target="_blank">http://codex.wordpress.org/Changing_File_Permissions</a> чтобы получить больше информации.');
            echo '</span>';
		echo '</p>';
	}
	//@ Если пользователь has too many rights
    if (!empty($acx_dbRights['rightsTooMuch'])) {
		echo '<p class="acx-info-box">';
            echo '<span class="acx-icon-alert-info">'. __("Вы в настоящее время используетесь пользователем для доступа к базе данных Wordpress <code>имеет слишком много прав</code>. Мы полагаем Вам, что бы вы ограничили свои права или использовали другой пользовательский профиль с более ограниченными правами вместо этого, чтобы повысить безопасность вашего сайта.").'</span>';
		echo '</p>';
    }
?>

<?php
/*
 * VALIDATE FORM
 *======================================================
 */
	 if ($wpsIsPostBack)
	 {
		 if (!empty($_POST['newPrefixInput']) && isset($_POST['changePrefixButton']))
		 {
			$cdtpIsPostBack = true;

			if (function_exists('wp_nonce_field')) {
				check_admin_referer('prefix-changer-change_prefix');
			}

			 //@@ Double check the request
			 if (!$isWPConfigWritable || !$canAlter)
			 {

				 $e  = __('пожалуйста исправьте следующие ошибки').':<br/>';
	    		 $e .= '<br/>'.__('У пользователе используемого для доступа к базе данных должны быть <strong>ALTER</strong> права для того, чтобы выполнить это действие!');
				 $e .= '<br/>'.__('Файл <strong>wp-config ДОЛЖЕН</strong> быть доступен для записи!');

				 wp_die($e);
			 }

             $wpdb = $GLOBALS['wpdb'];
             if (empty($wpdb))
             {
                 wp_die(__('Произошла внутренняя ошибка (empty $wpdb). Пожалуйста, сообщите об этой ошибке автору плагина. Спасибо!'));
             }

             $new_prefix = $_POST['newPrefixInput'];

             // validate prefix
             if(! preg_match('/^[a-zA-Z_][a-zA-Z0-9_]+$/', $new_prefix)){
                 $acxInfoMessage .=  sprintf('Неверный префикс имени таблицы: %s', htmlentities($new_prefix));
                 $new_prefix = $old_prefix;
             }
             else
             {
                 if (empty($acx_dbRights['rightsEnough']))
                 {
                     $wsd_Message .= '<span class="acx-icon-alert-critical">'. __('Пользователь, который используется для доступа к базе данных Wordpress, не имеет достаточно прав (отсутствует <code>ALTER</code> right) чтобы изменить структуру таблицы.
                            Если пользователь <code>уже имеет ALTER</code> с права и инструмент до сих пор не работает, пожалуйста, <a href="http://wordpress.org/support/plugin/wp-security-scan" target="_blank">свяжитесь с нами</a> для оказания помощи!').'</span>';
                 }

                 if (strlen($new_prefix) < strlen($_POST['newPrefixInput'])){
                     $acxInfoMessage .= __('Вы использовали некоторые запрещенные символы в именах таблиц. Санитарно обработанную префикс будет использоваться вместо').': '.$new_prefix;
                 }
                 if ($new_prefix == $old_prefix) {
                     if (!empty($acxInfoMessage)) { $acxInfoMessage .= '<br/>'; }
                     $acxInfoMessage .= __('Без изменений! Пожалуйста, выберите другое значение префикса таблицы.');
                 }
                 else
                 {
                     // Get the list of tables to modify
                     $tables = WsdUtil::getTablesToAlter();
                     if (empty($tables))
                     {
                         if (!empty($acxInfoMessage)) { $acxInfoMessage .= '<br/>'; }
                         $acxInfoMessage .= __("Внутренняя ошибка: мы не могли получить список таблиц из базы данных! Пожалуйста, сообщите автору плагина об этой ошибке! Спасибо!");
                     }
                     else
                     {
                         $result = WsdUtil::renameTables($tables, $old_prefix, $new_prefix);

                         // check for errors
                         if (!empty($result))
                         {
                             if (!empty($acxInfoMessage)) { $acxInfoMessage .= '<br/>'; }
                             $acxInfoMessage .= '<span class="acx-notice-success acx-icon-alert-success">'.__('Все таблицы были успешно обновлены!').'</span>';

                             // try to rename the fields
                             $acxInfoMessage .= WsdUtil::renameDbFields($old_prefix, $new_prefix);

                             if (0 < WsdUtil::updateWpConfigTablePrefix($wpConfigFile, $new_prefix))
                             {
                                 $acxInfoMessage .= '<br/><span class="acx-notice-success acx-icon-alert-success">'.__('<strong>wp-config</strong> файл был успешно обновлен!').'</span>';
                             }
                             else {
                                 $acxInfoMessage .= '<br/>'.__('<strong>wp-config</strong> файл не может быть обновлен! Вы должны вручную обновить <strong>$table_prefix</strong> переменную в одном указанном вами').': '.$new_prefix;
                             }
                         }// End if tables successfully renamed
                         else { $acxInfoMessage .= '<br/><strong>'.__('Произошла ошибка и таблицы не может быть обновлена!').'</strong>'; }
                     }// End if there are tables to rename
                 }// End checks
             }
		}// End if (!empty($_POST['newPrefixInput']))
	}// End if postback
    else { $new_prefix = $old_prefix; }

if(empty($new_prefix)){
    $new_prefix = $old_prefix;
}
?>

<?php
/*
* Dsplay the form
*=======================================================
*/
?>
<div class="acx-section-box">
    <form action="#cdtp" method="post" name="prefixchanging">
        <?php if (function_exists('wp_nonce_field')) { wp_nonce_field('prefix-changer-change_prefix'); } ?>
        <p><?php echo sprintf(__('Измените: <input type="text" name="newPrefixInput" value="%s" size="20" maxlength="15"/> префикс таблицы на что-то другое.'), $new_prefix); ?></p>
        <p><?php echo __('Допустимые символы: все латинские буквы и цифры, а также <strong>_</strong> (нижнее подчеркивание).');?></p>
        <input type="submit" class="button-primary" name="changePrefixButton" value="<?php echo __('Начать переименование');?>" />
    </form>
</div>
<div id="cdtp">
    <?php
        // Display status information
        if ($cdtpIsPostBack){
            if (!empty($acxInfoMessage)){ echo '<p class="acx-info-box">',$acxInfoMessage,'</p>'; }
            if (!empty($wsd_Message)) { echo '<p class="acx-info-box">',$wsd_Message,'</p>'; }
        }
        else {
            if (!empty($wsd_Message)) { echo '<p class="acx-info-box">',$wsd_Message,'</p>'; }
        }
    ?>
</div>
